/*
 * This file is generated by jOOQ.
 */
package org.transsonic.trustgame.data.trustgame.tables;


import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row16;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;
import org.transsonic.trustgame.data.trustgame.Indexes;
import org.transsonic.trustgame.data.trustgame.Keys;
import org.transsonic.trustgame.data.trustgame.Trustgame;
import org.transsonic.trustgame.data.trustgame.enums.CarrierService;
import org.transsonic.trustgame.data.trustgame.enums.CarrierSustainability;
import org.transsonic.trustgame.data.trustgame.tables.records.CarrierRecord;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Carrier extends TableImpl<CarrierRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>trustgame.carrier</code>
     */
    public static final Carrier CARRIER = new Carrier();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CarrierRecord> getRecordType() {
        return CarrierRecord.class;
    }

    /**
     * The column <code>trustgame.carrier.ID</code>.
     */
    public final TableField<CarrierRecord, Integer> ID = createField(DSL.name("ID"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>trustgame.carrier.Game_ID</code>.
     */
    public final TableField<CarrierRecord, Integer> GAME_ID = createField(DSL.name("Game_ID"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.Name</code>.
     */
    public final TableField<CarrierRecord, String> NAME = createField(DSL.name("Name"), SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.Slogan</code>.
     */
    public final TableField<CarrierRecord, String> SLOGAN = createField(DSL.name("Slogan"), SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.Logo</code>.
     */
    public final TableField<CarrierRecord, byte[]> LOGO = createField(DSL.name("Logo"), SQLDataType.BLOB.nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.Service</code>.
     */
    public final TableField<CarrierRecord, CarrierService> SERVICE = createField(DSL.name("Service"), SQLDataType.VARCHAR(6).nullable(false).asEnumDataType(org.transsonic.trustgame.data.trustgame.enums.CarrierService.class), this, "");

    /**
     * The column <code>trustgame.carrier.Sustainability</code>.
     */
    public final TableField<CarrierRecord, CarrierSustainability> SUSTAINABILITY = createField(DSL.name("Sustainability"), SQLDataType.VARCHAR(6).nullable(false).asEnumDataType(org.transsonic.trustgame.data.trustgame.enums.CarrierSustainability.class), this, "");

    /**
     * The column <code>trustgame.carrier.CompanyDescription</code>. HTML or Markdown
     */
    public final TableField<CarrierRecord, String> COMPANYDESCRIPTION = createField(DSL.name("CompanyDescription"), SQLDataType.CLOB.nullable(false), this, "HTML or Markdown");

    /**
     * The column <code>trustgame.carrier.WebsiteURL</code>.
     */
    public final TableField<CarrierRecord, String> WEBSITEURL = createField(DSL.name("WebsiteURL"), SQLDataType.VARCHAR(90).nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.OfficialReportDescription</code>. HTML or Markdown
     */
    public final TableField<CarrierRecord, String> OFFICIALREPORTDESCRIPTION = createField(DSL.name("OfficialReportDescription"), SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)), this, "HTML or Markdown");

    /**
     * The column <code>trustgame.carrier.OfficialReport</code>. HTML or Markdown
     */
    public final TableField<CarrierRecord, String> OFFICIALREPORT = createField(DSL.name("OfficialReport"), SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)), this, "HTML or Markdown");

    /**
     * The column <code>trustgame.carrier.CarrierType</code>.
     */
    public final TableField<CarrierRecord, String> CARRIERTYPE = createField(DSL.name("CarrierType"), SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>trustgame.carrier.GooglePage</code>.
     */
    public final TableField<CarrierRecord, String> GOOGLEPAGE = createField(DSL.name("GooglePage"), SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)), this, "");

    /**
     * The column <code>trustgame.carrier.GoogleImage</code>.
     */
    public final TableField<CarrierRecord, byte[]> GOOGLEIMAGE = createField(DSL.name("GoogleImage"), SQLDataType.BLOB.defaultValue(DSL.field("NULL", SQLDataType.BLOB)), this, "");

    /**
     * The column <code>trustgame.carrier.CarrierWebPage</code>.
     */
    public final TableField<CarrierRecord, String> CARRIERWEBPAGE = createField(DSL.name("CarrierWebPage"), SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)), this, "");

    /**
     * The column <code>trustgame.carrier.CarrierWebImage</code>.
     */
    public final TableField<CarrierRecord, byte[]> CARRIERWEBIMAGE = createField(DSL.name("CarrierWebImage"), SQLDataType.BLOB.defaultValue(DSL.field("NULL", SQLDataType.BLOB)), this, "");

    private Carrier(Name alias, Table<CarrierRecord> aliased) {
        this(alias, aliased, null);
    }

    private Carrier(Name alias, Table<CarrierRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>trustgame.carrier</code> table reference
     */
    public Carrier(String alias) {
        this(DSL.name(alias), CARRIER);
    }

    /**
     * Create an aliased <code>trustgame.carrier</code> table reference
     */
    public Carrier(Name alias) {
        this(alias, CARRIER);
    }

    /**
     * Create a <code>trustgame.carrier</code> table reference
     */
    public Carrier() {
        this(DSL.name("carrier"), null);
    }

    public <O extends Record> Carrier(Table<O> child, ForeignKey<O, CarrierRecord> key) {
        super(child, key, CARRIER);
    }

    @Override
    public Schema getSchema() {
        return Trustgame.TRUSTGAME;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CARRIER_FK_CARRIER_GAME1_IDX);
    }

    @Override
    public Identity<CarrierRecord, Integer> getIdentity() {
        return (Identity<CarrierRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<CarrierRecord> getPrimaryKey() {
        return Keys.KEY_CARRIER_PRIMARY;
    }

    @Override
    public List<UniqueKey<CarrierRecord>> getKeys() {
        return Arrays.<UniqueKey<CarrierRecord>>asList(Keys.KEY_CARRIER_PRIMARY, Keys.KEY_CARRIER_ID_UNIQUE);
    }

    @Override
    public List<ForeignKey<CarrierRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<CarrierRecord, ?>>asList(Keys.FK_CARRIER_GAME1);
    }

    private transient Game _game;

    public Game game() {
        if (_game == null)
            _game = new Game(this, Keys.FK_CARRIER_GAME1);

        return _game;
    }

    @Override
    public Carrier as(String alias) {
        return new Carrier(DSL.name(alias), this);
    }

    @Override
    public Carrier as(Name alias) {
        return new Carrier(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Carrier rename(String name) {
        return new Carrier(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Carrier rename(Name name) {
        return new Carrier(name, null);
    }

    // -------------------------------------------------------------------------
    // Row16 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row16<Integer, Integer, String, String, byte[], CarrierService, CarrierSustainability, String, String, String, String, String, String, byte[], String, byte[]> fieldsRow() {
        return (Row16) super.fieldsRow();
    }
}
